package org.jeecg.modules.ctop.controller;

import cn.com.ctop.crawler.modules.account.entity.KuaishouAdAccount;
import cn.com.ctop.crawler.modules.account.service.IKuaishouAdAccountService;
import cn.com.ctop.kuaishou.modules.app.entity.AppAd;
import cn.com.ctop.kuaishou.modules.app.entity.AppVideo;
import cn.com.ctop.kuaishou.modules.app.service.IAppAdService;
import cn.com.ctop.kuaishou.modules.app.service.IAppVideoService;
import cn.com.ctop.kuaishou.modules.app.service.IKuaishouAppService;
import cn.com.ctop.kuaishou.modules.graphql.entity.KuaishouVideo;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.gson.Gson;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.system.entity.SysCategory;
import org.jeecg.modules.system.service.ISysCategoryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("/ctop/adcover")
public class AdCoverController {
    @Autowired
    private IAppAdService appAdService;
    @Autowired
    private IAppVideoService appVideoService;
    @Autowired
    private IKuaishouAdAccountService kuaishouAdAccountService;
    @Autowired
    private ISysCategoryService sysCategoryService;
    @ResponseBody
    @RequestMapping(value="/feeds", method = RequestMethod.GET)
    public Result<List<AppAd>> getVideoList(HttpServletRequest req){
        Result<List<AppAd>> result = new Result<List<AppAd>>();
        AppAd ad = new AppAd();
        Map<String,String[]> paramMap = req.getParameterMap();
        String industry = paramMap.get("industry")!=null?sysCategoryService.getById(paramMap.get("industry")[0]).getName():null;
        String company = paramMap.get("company")!=null?paramMap.get("company")[0]:null;
        String product = paramMap.get("product")!=null?paramMap.get("product")[0]:null;
        String userName = paramMap.get("userName") != null ? paramMap.get("userName")[0] : null;
        String start = paramMap.get("start")!=null?paramMap.get("start")[0]:null;
        String end = paramMap.get("end")!=null?paramMap.get("end")[0]:null;
        String orderByColumn = paramMap.get("orderByColumn")!=null?paramMap.get("orderByColumn")[0]:null;
        String orderByType = paramMap.get("orderByType")!=null?paramMap.get("orderByType")[0]:null;
        Integer pageSize = paramMap.get("pageSize")!=null?Integer.parseInt(paramMap.get("pageSize")[0]):null;
        Integer pageNo = paramMap.get("pageNo")!=null?Integer.parseInt(paramMap.get("pageNo")[0]):null;
//        Integer pageSize = paramMap.get("pageSize")!=null?paramMap.get("orderByType")[0]:null;
        int pageStart = (pageNo-1)*pageSize;
        Page<AppAd> page = new Page<AppAd>(pageNo, pageSize);
        List<AppAd> list = appAdService.queryAdFeeds(userName, industry, company, product, start, end, orderByColumn, orderByType, pageStart, pageSize);
        result.setResult(list);
        result.setSuccess(true);
        return result;
    }

    //    @RequestMapping(value = "/list", method = RequestMethod.GET)
//    //@RequiresPermissions("sys:user:list")
//    public Result<IPage<SysUser>> queryPageList(SysUser user, @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
//                                                @RequestParam(name="pageSize", defaultValue="10") Integer pageSize, HttpServletRequest req) {
//        Result<IPage<SysUser>> result = new Result<IPage<SysUser>>();
//        QueryWrapper<SysUser> queryWrapper = QueryGenerator.initQueryWrapper(user, req.getParameterMap());
//        Page<SysUser> page = new Page<SysUser>(pageNo, pageSize);
//        IPage<SysUser> pageList = sysUserService.page(page, queryWrapper);
//        result.setSuccess(true);
//        result.setResult(pageList);
//        return result;
//    }
    @ResponseBody
    @RequestMapping(value="/detail", method = RequestMethod.GET)
    public Result<Map<String,Object>> getDetail(@RequestParam(name="photoId") Long photoId, @RequestParam(name="userId") Long userId){
        Result<Map<String,Object>> result = new Result<Map<String,Object>>();
        AppAd ad = new AppAd();
        ad.setPhotoId(photoId);
        QueryWrapper<AppAd> queryWrapper = QueryGenerator.initQueryWrapper(ad,null);
        List<AppAd> list = appAdService.list(queryWrapper);
        AppVideo video = appVideoService.getById(photoId);
        KuaishouAdAccount kuaishouAdAccount = kuaishouAdAccountService.getById(userId);
        if(kuaishouAdAccount == null){
            kuaishouAdAccount = new KuaishouAdAccount();
        }
        ad = list.get(0);
        if(video == null){
            video = new AppVideo();
            video.setMvUrl(ad.getMvUrl());
        }

        kuaishouAdAccount.setUrl("https://live.kuaishou.com/profile/" + ad.getShareInfo().substring(ad.getShareInfo().indexOf("=") + 1, ad.getShareInfo().indexOf("&")));
        video.setShareInfo("https://live.kuaishou.com/u/" + ad.getShareInfo().replace("userId=", "").replace("photoId=", "").replace("&", "/"));
        Map<String,Object> map = new HashMap<String,Object>();
        map.put("adlist",list);
        map.put("user",kuaishouAdAccount);
        map.put("video",video);
        result.setResult(map);
        result.setSuccess(true);
        return result;
    }

    @ResponseBody
    @RequestMapping(value="/adlist", method = RequestMethod.GET)
    public Result<List<AppAd>> getAdList(@RequestParam(name="photoId") String photoId, @RequestParam(name="userId") Long userId){
        Result<List<AppAd>> result = new Result<List<AppAd>>();
        AppAd ad = new AppAd();
        ad.setPhotoId(Long.valueOf(photoId));
        QueryWrapper<AppAd> queryWrapper = QueryGenerator.initQueryWrapper(ad,null);
        List<AppAd> list = appAdService.list(queryWrapper);
        result.setResult(list);
        result.setSuccess(true);
        return result;
    }
}
