package org.jeecg.modules.ctop.controller;

import cn.com.ctop.kuaishou.modules.material.entity.KuaishouAccessToken;
import cn.com.ctop.kuaishou.modules.material.entity.KuaishouResultToken;
import cn.com.ctop.kuaishou.modules.material.service.IKuaishouAccessTokenService;
import org.apache.commons.lang.StringUtils;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.mapper.CTopOauthTokenMapper;
import org.jeecg.modules.kuaishou.service.IKuaishouInterfaceService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

@Controller
@RequestMapping("/")
public class CallbackController {
    @Autowired
    private IKuaishouInterfaceService kuaishouInterfaceService;
    @Autowired
    private IKuaishouAccessTokenService kuaishouAccessTokenService;
    @Autowired
    private CTopOauthTokenMapper cTopOauthTokenMapper;

    @RequestMapping("/kuaishou")
    @ResponseBody
    public String kuaishou(HttpServletRequest request,
                           HttpServletResponse response,
                           @RequestParam("auth_code") String authCode,
                           @RequestParam("state") String state) {
        if (StringUtils.isNotBlank(authCode)) {
            KuaishouResultToken accessToken = kuaishouInterfaceService.getAccessToken(authCode);
            KuaishouAccessToken token = accessToken.getData();
            if (token != null) {
                CTopOauthToken topOauthToken = new CTopOauthToken();
                Long accountId = token.getAccountId();
                topOauthToken.setAccountId(token.getAccountId());
                topOauthToken.setMediaId("2");
                topOauthToken.setAdvertiserId(state);
                topOauthToken.setAccessToken(token.getAccessToken());
                long accessTokenExpireIn = token.getAccessTokenExpiresIn() * 1000L;
                long now = System.currentTimeMillis();
                Date accessTokenExpireInDate = new Date(now + accessTokenExpireIn);
                topOauthToken.setAccessTokenExpiresIn(accessTokenExpireInDate);
                topOauthToken.setRefreshToken(token.getRefreshToken());
                long refreshTokenExpireIn = token.getRefreshTokenExpiresIn() * 1000L;
                Date refreshTokenExpireInDate = new Date(now + refreshTokenExpireIn);
                topOauthToken.setRefreshTokenExpiresIn(refreshTokenExpireInDate);

                Map<String, Object> map = new HashMap<>();
                map.put("account_id", accountId);

            }
            return "auth_success";
        }
        return "auth_fail";
    }
}
