package org.jeecg.modules.ctop.controller;

import cn.com.ctop.kuaishou.modules.graphql.entity.KuaishouVideo;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouVideoService;
import cn.com.ctop.kuaishou.modules.graphql.service.IKuaishouWebInterfaceService;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.gson.JsonObject;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.system.entity.SysRole;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

@Controller
@RequestMapping("/graphql")
public class GraphqlController {
    @Autowired
    private IKuaishouWebInterfaceService kuaishouWebInterfaceService;
    @Autowired
    private IKuaishouVideoService kuaishouVideoService;
    @RequestMapping("/video")
    public void getVideoList(@RequestParam("uid") String uid){
        kuaishouWebInterfaceService.getVideoList(uid);
    }
    @ResponseBody
    @RequestMapping(value="/addkuaishouuser", method = RequestMethod.POST)
    public Result<Map<String,Object>> addKuaishouUser(@RequestBody JSONObject jsonObject){
        String url = jsonObject.getString("url");
        System.out.println(jsonObject.toString());
        String uid = kuaishouWebInterfaceService.checkKuaishouUser(url);
        Map<String,Object> resultMap = new HashMap<String, Object>();
        if(uid == null){
            resultMap.put("hasUser",false);
        }else {
            resultMap.put("hasUser",true);
            Thread thread = new Thread(){
                @Override
                public void run() {
                    kuaishouWebInterfaceService.getVideoList(uid);
                }
            };
            thread.start();
        }
        Result<Map<String,Object>> result = new Result<Map<String,Object>>();
        result.setSuccess(true);
        result.setResult(resultMap);
        return result;
    }
    @ResponseBody
    @RequestMapping(value="/publicfeeds", method = RequestMethod.GET)
    public Result<IPage<KuaishouVideo>> getVideoList(@RequestParam("num") Integer num){
        if(num==null){
            num=99999999;
        }
        Result<IPage<KuaishouVideo>> result = new Result<IPage<KuaishouVideo>>();
        KuaishouVideo video = new KuaishouVideo();
        QueryWrapper<KuaishouVideo> queryWrapper = QueryGenerator.initQueryWrapper(video,null);
        queryWrapper.orderByDesc("num");
        queryWrapper.le("num",num);
        System.out.println("num="+num);
        Page<KuaishouVideo> page = new Page<KuaishouVideo>(1, 20);
        IPage<KuaishouVideo> pageList = kuaishouVideoService.page(page,queryWrapper);
        result.setResult(pageList);
        result.setSuccess(true);
        return result;
    }
}
