package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 今日头条广告计划信息
 * @Author: jeecg-boot
 * @Date: 2019-07-22
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_advertise_plan")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_advertise_plan对象", description = "今日头条广告计划信息")
public class ByteDanceAdvertisePlan {
    
	/**头条平台广告计划id*/
    @TableId
    @ApiModelProperty(value = "头条平台广告计划id")
	private Long id;
	/**平台广告主id*/
	@Excel(name = "平台广告主id", width = 15)
    @ApiModelProperty(value = "平台广告主id")
	private String advertiserId;
	/**头条广告主id*/
	@Excel(name = "头条广告主id", width = 15)
    @ApiModelProperty(value = "头条广告主id")
	private Long toutiaoId;
	/**计划名称*/
	@Excel(name = "计划名称", width = 15)
    @ApiModelProperty(value = "计划名称")
	private String name;
	/**广告组id*/
	@Excel(name = "广告组id", width = 15)
    @ApiModelProperty(value = "广告组id")
	private Long campaignId;
	/**上次修改时间戳(用于更新时提交,服务端判断是否基于最新信息修改)*/
	@Excel(name = "上次修改时间戳(用于更新时提交,服务端判断是否基于最新信息修改)", width = 15)
    @ApiModelProperty(value = "上次修改时间戳(用于更新时提交,服务端判断是否基于最新信息修改)")
	private String planModifyTime;
	/**投放范围*/
	@Excel(name = "投放范围", width = 15)
    @ApiModelProperty(value = "投放范围")
	private String deliveryRange;
	/**计划上次修改时间*/
	@Excel(name = "计划上次修改时间", width = 15)
    @ApiModelProperty(value = "计划上次修改时间")
	private String adModifyTime;
	/**计划创建时间*/
	@Excel(name = "计划创建时间", width = 15)
    @ApiModelProperty(value = "计划创建时间")
	private String adCreateTime;
	/**广告预算类型*/
	@Excel(name = "广告预算类型", width = 15)
    @ApiModelProperty(value = "广告预算类型")
	private String budgetMode;
	/**广告预算*/
	@Excel(name = "广告预算", width = 15)
    @ApiModelProperty(value = "广告预算")
	private java.math.BigDecimal budget;
	/**广告计划投放状态*/
	@Excel(name = "广告计划投放状态", width = 15)
    @ApiModelProperty(value = "广告计划投放状态")
	private String toutiaoStatus;
	/**广告计划操作状态*/
	@Excel(name = "广告计划操作状态", width = 15)
    @ApiModelProperty(value = "广告计划操作状态")
	private String optStatus;
	/**广告投放起始时间*/
	@Excel(name = "广告投放起始时间", width = 15)
    @ApiModelProperty(value = "广告投放起始时间")
	private String startTime;
	/**广告投放结束时间*/
	@Excel(name = "广告投放结束时间", width = 15)
    @ApiModelProperty(value = "广告投放结束时间")
	private String endTime;
	/**广告出价*/
	@Excel(name = "广告出价", width = 15)
    @ApiModelProperty(value = "广告出价")
	private java.math.BigDecimal bid;
	/**广告出价类型*/
	@Excel(name = "广告出价类型", width = 15)
    @ApiModelProperty(value = "广告出价类型")
	private String pricing;
	/**广告投放时间类型*/
	@Excel(name = "广告投放时间类型", width = 15)
    @ApiModelProperty(value = "广告投放时间类型")
	private String scheduleType;
	/**广告投放时段*/
	@Excel(name = "广告投放时段", width = 15)
    @ApiModelProperty(value = "广告投放时段")
	private String scheduleTime;
	/**广告投放速度类型*/
	@Excel(name = "广告投放速度类型", width = 15)
    @ApiModelProperty(value = "广告投放速度类型")
	private String flowControlMode;
	/**应用直达链接*/
	@Excel(name = "应用直达链接", width = 15)
    @ApiModelProperty(value = "应用直达链接")
	private String openUrl;
	/**应用下载方式*/
	@Excel(name = "应用下载方式", width = 15)
    @ApiModelProperty(value = "应用下载方式")
	private String downloadType;
	/**广告落地页链接*/
	@Excel(name = "广告落地页链接", width = 15)
    @ApiModelProperty(value = "广告落地页链接")
	private String externalUrl;
	/**广告应用下载包名*/
	@Excel(name = "广告应用下载包名", width = 15)
    @ApiModelProperty(value = "广告应用下载包名")
	private String toutiaoPackage;
	/**广告应用下载类型*/
	@Excel(name = "广告应用下载类型", width = 15)
    @ApiModelProperty(value = "广告应用下载类型")
	private String appType;
	/**广告计划审核不通过原因*/
	@Excel(name = "广告计划审核不通过原因", width = 15)
    @ApiModelProperty(value = "广告计划审核不通过原因")
	private String auditRejectReason;
	/**ocpc广告转化出价*/
	@Excel(name = "ocpc广告转化出价", width = 15)
    @ApiModelProperty(value = "ocpc广告转化出价")
	private java.math.BigDecimal cpaBid;
	/**ocpc广告是否跳过第一阶段*/
	@Excel(name = "ocpc广告是否跳过第一阶段", width = 15)
    @ApiModelProperty(value = "ocpc广告是否跳过第一阶段")
	private Integer cpaSkipFirstPhrase;
	/**转化类型广告的转化工具id*/
	@Excel(name = "转化类型广告的转化工具id", width = 15)
    @ApiModelProperty(value = "转化类型广告的转化工具id")
	private Long convertId;
	/**过滤已转化用户类型字段*/
	@Excel(name = "过滤已转化用户类型字段", width = 15)
    @ApiModelProperty(value = "过滤已转化用户类型字段")
	private String hideIfConverted;
	/**过滤已安装，当推广目标为安卓应用下载时可填*/
	@Excel(name = "过滤已安装，当推广目标为安卓应用下载时可填", width = 15)
    @ApiModelProperty(value = "过滤已安装，当推广目标为安卓应用下载时可填")
	private Integer hideIfExists;
	/**audience*/
	@Excel(name = "audience", width = 15)
    @ApiModelProperty(value = "audience")
	private Object audience;

    public ByteDanceAdvertisePlan(JSONObject dataObject, String accountId) {
		Long id = dataObject.getLong("id");
		this.id=id;
		this.advertiserId = accountId;
		String name = dataObject.getString("name");
		if (null!=name&&!"".equals(name.trim())){
			this.name =name;
		}

		Long advertiserId = dataObject.getLong("advertiser_id");
		if (null!=advertiserId){
			this.toutiaoId =advertiserId;
		}
		Long campaignId = dataObject.getLong("campaign_id");
		if (null!=campaignId){
			this.campaignId =campaignId;
		}

		String budget_mode = dataObject.getString("budget_mode");
		if (null!=budget_mode&&!"".equals(budget_mode.trim())){
			this.budgetMode =budget_mode;
		}

        String open_url = dataObject.getString("open_url");
        if (null != open_url && !"".equals(open_url.trim())) {
            this.openUrl = open_url;
        }

        String ad_create_time = dataObject.getString("ad_create_time");
        if (null != ad_create_time && !"".equals(ad_create_time.trim())) {
            this.adCreateTime = ad_create_time;
        }

        String ad_modify_time = dataObject.getString("ad_modify_time");
        if (null != ad_modify_time && !"".equals(ad_modify_time.trim())) {
            this.adModifyTime = ad_modify_time;
        }

        String audit_reject_reason = dataObject.getString("audit_reject_reason");
        if (null != audit_reject_reason && !"".equals(audit_reject_reason.trim())) {
            this.auditRejectReason = audit_reject_reason;
        }

//        String dpa_open_url_field = dataObject.getString("dpa_open_url_field");
//        if (null!=dpa_open_url_field&&!"".equals(dpa_open_url_field.trim())){
//            this.dpa =dpa_open_url_field;
//        }

//        String external_url_params = dataObject.getString("external_url_params");
//        if (null!=external_url_params&&!"".equals(external_url_params.trim())){
//            this.externalUrlParams =external_url_params;
//        }

        String pricing = dataObject.getString("pricing");
        if (null != pricing && !"".equals(pricing.trim())) {
            this.pricing = pricing;
        }

//        String dpa_open_url_type = dataObject.getString("dpa_open_url_type");
//        if (null!=dpa_open_url_type&&!"".equals(dpa_open_url_type.trim())){
//            this.dpaOpenUrlType =dpa_open_url_type;
//        }

//        String dpa_categories = dataObject.getString("dpa_categories");
//        if (null!=dpa_categories&&!"".equals(dpa_categories.trim())){
//            this.dpaCategories =dpa_categories;
//        }

        Integer hide_if_exists = dataObject.getInteger("hide_if_exists");
        if (null != hide_if_exists) {
            this.hideIfExists = hide_if_exists;
        }

//        String open_url_params = dataObject.getString("open_url_params");
//        if (null!=open_url_params&&!"".equals(open_url_params.trim())){
//            this.openUrlParams =open_url_params;
//        }

//        String dpa_open_urls = dataObject.getString("dpa_open_urls");
//        if (null!=dpa_open_urls&&!"".equals(dpa_open_urls.trim())){
//            this.dpaOpenUrls =dpa_open_urls;
//        }

//        String deep_cpabid = dataObject.getString("deep_cpabid");
//        if (null!=deep_cpabid&&!"".equals(deep_cpabid.trim())){
//            this.deepCpaaid =deep_cpabid;
//        }

        String app_type = dataObject.getString("app_type");
        if (null != app_type && !"".equals(app_type.trim())) {
            this.appType = app_type;
        }

        String flow_control_mode = dataObject.getString("flow_control_mode");
        if (null != flow_control_mode && !"".equals(flow_control_mode.trim())) {
            this.flowControlMode = flow_control_mode;
        }

//        String union_video_type = dataObject.getString("union_video_type");
//        if (null!=union_video_type&&!"".equals(union_video_type.trim())){
//            this.unionVideoType =union_video_type;
//        }

//        String download_url = dataObject.getString("download_url");
//        if (null!=download_url&&!"".equals(download_url.trim())){
//            this.downloadUrl =download_url;
//        }

        BigDecimal cpa_bid = dataObject.getBigDecimal("cpa_bid");
        if (null != cpa_bid) {
            this.cpaBid = cpa_bid;
        }

//        String dpa_products = dataObject.getString("dpa_products");
//        if (null!=dpa_products&&!"".equals(dpa_products.trim())){
//            this.dpaProducts =dpa_products;
//        }

//        String category_type = dataObject.getString("category_type");
//        if (null!=category_type&&!"".equals(category_type.trim())){
//            this.categoryType =category_type;
//        }

//        String dpa_external_url_field = dataObject.getString("dpa_external_url_field");
//        if (null!=dpa_external_url_field&&!"".equals(dpa_external_url_field.trim())){
//            this.dpaExternalUrlField =dpa_external_url_field;
//        }

//        String smart_bid_type = dataObject.getString("smart_bid_type");
//        if (null!=smart_bid_type&&!"".equals(smart_bid_type.trim())){
//            this.smartBidType =smart_bid_type;
//        }

//        String dpa_external_urls = dataObject.getString("dpa_external_urls");
//        if (null!=dpa_external_urls&&!"".equals(dpa_external_urls.trim())){
//            this.dpaExternalUrls =dpa_external_urls;
//        }

        String start_time = dataObject.getString("start_time");
        if (null != start_time && !"".equals(start_time.trim())) {
            this.startTime = start_time;
        }

        String opt_status = dataObject.getString("opt_status");
        if (null != opt_status && !"".equals(opt_status.trim())) {
            this.optStatus = opt_status;
        }

        String end_time = dataObject.getString("end_time");
        if (null != end_time && !"".equals(end_time.trim())) {
            this.endTime = end_time;
        }

        String status = dataObject.getString("status");
        if (null != status && !"".equals(status.trim())) {
            this.toutiaoStatus = status;
        }

//        String dpa_product_target = dataObject.getString("dpa_product_target");
//        if (null!=dpa_product_target&&!"".equals(dpa_product_target.trim())){
//            this.dpaProductTarget =dpa_product_target;
//        }

//        Long ad_id = dataObject.getLong("ad_id");
//        if (null!=ad_id){
//            this.openUrl =open_url;
//        }

        Long convert_id = dataObject.getLong("convert_id");
        if (null != convert_id) {
            this.convertId = convert_id;
        }

//        String adjust_cpa = dataObject.getString("adjust_cpa");
//        if (null!=adjust_cpa&&!"".equals(adjust_cpa.trim())){
//            this.adjustCpa =adjust_cpa;
//        }

        BigDecimal bid = dataObject.getBigDecimal("bid");
        if (null != bid) {
            this.bid = bid;
        }

//        Long advertiser_id = dataObject.getLong("advertiser_id");
//        if (null!=advertiser_id){
//            this.asdasd =open_url;
//        }

//        String deep_bid_type = dataObject.getString("deep_bid_type");
//        if (null!=deep_bid_type&&!"".equals(deep_bid_type.trim())){
//            this.deepBidType =deep_bid_type;
//        }
//
//        String dpa_adtype = dataObject.getString("dpa_adtype");
//        if (null!=dpa_adtype&&!"".equals(dpa_adtype.trim())){
//            this.dpaAdtype =dpa_adtype;
//        }

//        String external_actions = dataObject.getString("external_actions");
//        if (null!=external_actions&&!"".equals(external_actions.trim())){
//            this.externalActions =external_actions;
//        }

        String hide_if_converted = dataObject.getString("hide_if_converted");
        if (null != hide_if_converted && !"".equals(hide_if_converted.trim())) {
            this.hideIfConverted = hide_if_converted;
        }

        String toutiaoPackage = dataObject.getString("package");
        if (null != toutiaoPackage && !"".equals(toutiaoPackage.trim())) {
            this.toutiaoPackage = toutiaoPackage;
        }

        String delivery_range = dataObject.getString("delivery_range");
        if (null != delivery_range && !"".equals(delivery_range.trim())) {
            this.deliveryRange = delivery_range;
        }

//        String params_type = dataObject.getString("params_type");
//        if (null!=params_type&&!"".equals(params_type.trim())){
//            this.paramsType =params_type;
//        }

        BigDecimal budget = dataObject.getBigDecimal("budget");
        if (null != budget) {
            this.budget = budget;
        }

        String schedule_type = dataObject.getString("schedule_type");
        if (null != schedule_type && !"".equals(schedule_type.trim())) {
            this.scheduleType = schedule_type;
        }

        String schedule_time = dataObject.getString("schedule_time");
        if (null != schedule_time && !"".equals(schedule_time.trim())) {
            this.scheduleTime = schedule_time;
        }
//
//        String modify_time = dataObject.getString("modify_time");
//        if (null!=modify_time&&!"".equals(modify_time.trim())){
//            this.modifyTime =modify_time;
//        }
//
//        String advertiser_store_ids = dataObject.getString("advertiser_store_ids");
//        if (null!=advertiser_store_ids&&!"".equals(advertiser_store_ids.trim())){
//            this.advertiserStoreIds =advertiser_store_ids;
//        }

//        String product_platform_id = dataObject.getString("product_platform_id");
//        if (null!=product_platform_id&&!"".equals(product_platform_id.trim())){
//            this.productPlatformId =product_platform_id;
//        }

        String download_type = dataObject.getString("download_type");
        if (null != download_type && !"".equals(download_type.trim())) {
            this.downloadType = download_type;
        }

        String external_url = dataObject.getString("external_url");
        if (null != external_url && !"".equals(external_url.trim())) {
            this.externalUrl = external_url;
        }
    }

    public ByteDanceAdvertisePlan() {

    }


}
