package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 今日头条广告组信息
 * @Author: jeecg-boot
 * @Date: 2019-07-22
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_campaign")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_campaign对象", description = "今日头条广告组信息")
public class ByteDanceCampaign {
    
	/**今日头条广告组id*/
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "今日头条广告组id")
	private Long id;
	/**平台用户id*/
	@Excel(name = "平台用户id", width = 15)
    @ApiModelProperty(value = "平台用户id")
	private String advertiserId;
	/**头条账号id*/
	@Excel(name = "头条账号id", width = 15)
    @ApiModelProperty(value = "头条账号id")
	private Long toutiaoId;
	/**广告组名称*/
	@Excel(name = "广告组名称", width = 15)
    @ApiModelProperty(value = "广告组名称")
	private String name;
	/**广告组预算*/
	@Excel(name = "广告组预算", width = 15)
    @ApiModelProperty(value = "广告组预算")
	private java.math.BigDecimal budget;
	/**广告组预算类型*/
	@Excel(name = "广告组预算类型", width = 15)
    @ApiModelProperty(value = "广告组预算类型")
	private String budgetMode;
	/**广告组推广目的*/
	@Excel(name = "广告组推广目的", width = 15)
    @ApiModelProperty(value = "广告组推广目的")
	private String landingType;
	/**广告组时间戳,用于更新时提交,服务端判断是否基于最新信息修改*/
	@Excel(name = "广告组时间戳,用于更新时提交,服务端判断是否基于最新信息修改", width = 15)
    @ApiModelProperty(value = "广告组时间戳,用于更新时提交,服务端判断是否基于最新信息修改")
	private String modifyTime;
	@Excel(name = "广告组状态", width = 15)
    @ApiModelProperty(value = "广告组状态")
    private java.lang.String status;
    /**
     * optStatus
     */
    @Excel(name = "optStatus", width = 15)
    @ApiModelProperty(value = "optStatus")
    private java.lang.String optStatus;
	/**广告组创建时间*/
	@Excel(name = "广告组创建时间", width = 15)
    @ApiModelProperty(value = "广告组创建时间")
	private java.lang.String campaignCreateTime;
	/**广告组修改时间*/
	@Excel(name = "广告组修改时间", width = 15)
    @ApiModelProperty(value = "广告组修改时间")
	private java.lang.String campaignModifyTime;
	/**createTime*/
    @ApiModelProperty(value = "createTime")
	private java.util.Date createTime;
	/**updateTime*/
    @ApiModelProperty(value = "updateTime")
	private java.util.Date updateTime;

    public ByteDanceCampaign() {
    }

    public ByteDanceCampaign(Long id, String advertiserId, Long toutiaoId, String name, BigDecimal budget, String budgetMode, String landingType, String modifyTime, String status, String optStatus, String campaignCreateTime, String campaignModifyTime, Date createTime, Date updateTime) {
		this.id = id;
		this.advertiserId = advertiserId;
		this.toutiaoId = toutiaoId;
		this.name = name;
		this.budget = budget;
		this.budgetMode = budgetMode;
		this.landingType = landingType;
		this.modifyTime = modifyTime;
		this.status = status;
		this.optStatus = optStatus;
		this.campaignCreateTime = campaignCreateTime;
		this.campaignModifyTime = campaignModifyTime;
		this.createTime = createTime;
		this.updateTime = updateTime;
    }

    public ByteDanceCampaign(JSONObject dataObject, String accountId) {
		Long id = dataObject.getLong("id");
		this.id = id;
		this.advertiserId = accountId;
		Long toutiaoId = dataObject.getLong("advertiser_id");
		if (null!=toutiaoId){
			this.toutiaoId =toutiaoId;
		}
		String name = dataObject.getString("name");
		if (null!=name&&!"".equals(name.trim())){
			this.name =name;
		}
		BigDecimal budget = dataObject.getBigDecimal("budget");
		if (null!=budget){
			this.budget =budget;
		}
		String budgetMode = dataObject.getString("budget_mode");
		if (null!=budgetMode&&!"".equals(budgetMode.trim())){
			this.budgetMode =budgetMode;
		}
		String landingType = dataObject.getString("landing_type");
		if (null!=landingType&&!"".equals(landingType.trim())){
			this.landingType =landingType;
		}
		String modify_time = dataObject.getString("modify_time");
		if (null!=modify_time&&!"".equals(modify_time.trim())){
			this.modifyTime =modify_time;
		}
		String status = dataObject.getString("status");
		if (null!=status&&!"".equals(status.trim())){
			this.status =status;
		}
		String optStatus = dataObject.getString("opt_status");
		if (null!=optStatus&&!"".equals(optStatus.trim())){
			this.optStatus =optStatus;
		}
		String campaign_create_time  = dataObject.getString("campaign_create_time ");
		if (null!=campaign_create_time &&!"".equals(campaign_create_time .trim())){
			this.campaignCreateTime  =campaign_create_time ;
		}
		String campaign_modify_time = dataObject.getString("campaign_modify_time");
		if (null!=campaign_modify_time&&!"".equals(campaign_modify_time.trim())){
			this.campaignModifyTime =campaign_modify_time;
        }
    }

    public ByteDanceCampaign(Long id, CTopOauthToken oauthToken, String campaignName, String budgetMode, Integer budget, String landingType) {
		this.id = id;
		this.advertiserId = oauthToken.getAdvertiserId();
		this.name = campaignName;
		this.budgetMode = budgetMode;
		this.budget = BigDecimal.valueOf(budget);
		this.landingType = landingType;
		this.toutiaoId = oauthToken.getAccountId();
	}
}
