package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 今日头条广告组模板信息
 * @Author: jeecg-boot
 * @Date: 2019-07-22
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_campaign_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_campaign_template对象", description = "今日头条广告组模板信息")
public class ByteDanceCampaignTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * accountId
     */
    @Excel(name = "头条账号id")
    @ApiModelProperty(value = "头条账号id")
    private Long accountId;
    @Excel(name = "平台广告主id")
    @ApiModelProperty(value = "平台广告主id")
    private String advertiserId;
    /**
     * 投放目标
     */
    @Excel(name = "投放目标", width = 15)
    @ApiModelProperty(value = "投放目标")
    private String promotionPurpuse;
    /**
     * 投放方式
     */
    @Excel(name = "投放方式", width = 15)
    @ApiModelProperty(value = "投放方式")
    private String campaignBudget;
    /**
     * 日预算
     */
    @Excel(name = "日预算", width = 15)
    @ApiModelProperty(value = "日预算")
    private String budgetDaily;
    /**
     * 广告组名称
     */
    @Excel(name = "广告组名称", width = 15)
    @ApiModelProperty(value = "广告组名称")
    private String campaignName;
    /**
     * 模板状态
     */
    @Excel(name = "模板状态", width = 15)
    @ApiModelProperty(value = "模板状态")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
