package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.util.Date;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 今日头条创意信息
 * @Author: jeecg-boot
 * @Date: 2019-07-22
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_creative")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_creative对象", description = "今日头条创意信息")
public class ByteDanceCreative {
    
	/**创意id*/
    @TableId
    @ApiModelProperty(value = "创意id")
	private Long id;
	/**广告计划id*/
	@Excel(name = "广告计划id", width = 15)
    @ApiModelProperty(value = "广告计划id")
	private Long planId;
	/**头条平台id*/
	@Excel(name = "头条平台id", width = 15)
    @ApiModelProperty(value = "头条平台id")
	private Long toutiaoId;
	/**本平台广告主id*/
	@Excel(name = "本平台广告主id", width = 15)
    @ApiModelProperty(value = "本平台广告主id")
	private String accountId;
	/**创意素材标题*/
	@Excel(name = "创意素材标题", width = 15)
    @ApiModelProperty(value = "创意素材标题")
	private String title;
	/**动态词包列表*/
	@Excel(name = "动态词包列表", width = 15)
    @ApiModelProperty(value = "动态词包列表")
	private String creativeWordIds;
	/**创意素材状态*/
	@Excel(name = "创意素材状态", width = 15)
    @ApiModelProperty(value = "创意素材状态")
	private String status;
	/**创意素材创作状态*/
	@Excel(name = "创意素材创作状态", width = 15)
    @ApiModelProperty(value = "创意素材创作状态")
	private String optStatus;
	/**创意素材类型*/
	@Excel(name = "创意素材类型", width = 15)
    @ApiModelProperty(value = "创意素材类型")
	private String imageMode;
	/**图片素材id列表*/
	@Excel(name = "图片素材id列表", width = 15)
    @ApiModelProperty(value = "图片素材id列表")
	private String imageIds;
	/**视频素材封面*/
	@Excel(name = "视频素材封面", width = 15)
    @ApiModelProperty(value = "视频素材封面")
	private String imageId;
	/**视频id*/
	@Excel(name = "视频id", width = 15)
    @ApiModelProperty(value = "视频id")
	private String videoId;
	/**创意审核信息*/
	@Excel(name = "创意审核信息", width = 15)
    @ApiModelProperty(value = "创意审核信息")
	private String auditRejectReason;
	/**第三方id*/
	@Excel(name = "第三方id", width = 15)
    @ApiModelProperty(value = "第三方id")
	private String thirdPartyId;
	/**广告创意创建时间*/
	@Excel(name = "广告创意创建时间", width = 15)
    @ApiModelProperty(value = "广告创意创建时间")
	private String creativeCreateTime;
	/**广告创意更新时间*/
	@Excel(name = "广告创意更新时间", width = 15)
    @ApiModelProperty(value = "广告创意更新时间")
	private String creativeModifyTime;
	/**createTime*/
    @ApiModelProperty(value = "createTime")
	private Date createTime;
	/**updateTime*/
    @ApiModelProperty(value = "updateTime")
	private Date updateTime;

    public ByteDanceCreative(JSONObject dataObject, String accountId) {
		this.id = dataObject.getLong("creative_id");
		this.planId = dataObject.getLong("ad_id");
		this.toutiaoId = dataObject.getLong("advertiser_id");
		this.accountId = accountId;
		String title = dataObject.getString("title");
		if (null!=title&&!"".equals(title.trim())){
			this.title = title;
		}
		String creative_word_ids = dataObject.getString("creative_word_ids");
		if (null!=creative_word_ids&&!"".equals(creative_word_ids.trim())){
			this.creativeWordIds = creative_word_ids;
		}
		String status = dataObject.getString("status");
		if (null!=status&&!"".equals(status.trim())){
			this.status = status;
		}
		String opt_status = dataObject.getString("opt_status");
		if (null!=opt_status&&!"".equals(opt_status.trim())){
			this.optStatus = opt_status;
		}
		String image_mode = dataObject.getString("image_mode");
		if (null!=image_mode&&!"".equals(image_mode.trim())){
			this.imageMode = image_mode;
		}
		String image_ids = dataObject.getString("image_ids");
		if (null!=image_ids&&!"".equals(image_ids.trim())){
			this.imageIds = image_ids;
		}
		String image_id = dataObject.getString("image_id");
		if (null!=image_id&&!"".equals(image_id.trim())){
			this.imageId = image_id;
		}
		String video_id = dataObject.getString("video_id");
		if (null!=video_id&&!"".equals(video_id.trim())){
			this.videoId = video_id;
		}
		String third_party_id = dataObject.getString("third_party_id");
		if (null!=third_party_id&&!"".equals(third_party_id.trim())){
			this.thirdPartyId = third_party_id;
		}
		String audit_reject_reason = dataObject.getString("audit_reject_reason");
		if (null!=audit_reject_reason&&!"".equals(audit_reject_reason.trim())){
			this.auditRejectReason = audit_reject_reason;
		}
		String creative_create_time = dataObject.getString("creative_create_time");
		if (null!=creative_create_time&&!"".equals(creative_create_time.trim())){
			this.creativeCreateTime = creative_create_time;
		}
		String creative_modify_time = dataObject.getString("creative_modify_time");
		if (null!=creative_modify_time&&!"".equals(creative_modify_time.trim())){
			this.creativeModifyTime = creative_modify_time;
		}
//		String materials = dataObject.getString("materials");
//		if (null!=materials&&!"".equals(materials.trim())){
//			this.materials = materials;
//		}
	}

    public ByteDanceCreative() {
	}
}
