package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.util.Date;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 今日头条创意素材信息
 * @Author: jeecg-boot
 * @Date: 2019-07-22
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_creative_material")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_creative_material对象", description = "今日头条创意素材信息")
public class ByteDanceCreativeMaterial {
    
	/**素材id*/
    @TableId
    @ApiModelProperty(value = "素材id")
	private Long id;
	/**平台广告主id*/
	@Excel(name = "平台广告主id", width = 15)
    @ApiModelProperty(value = "平台广告主id")
	private String advertiserId;
	/**广告id*/
	@Excel(name = "广告id", width = 15)
    @ApiModelProperty(value = "广告id")
	private Long adId;
	/**头天广告主id*/
	@Excel(name = "头天广告主id", width = 15)
    @ApiModelProperty(value = "头天广告主id")
	private Long toutiaoId;
	/**创意标题*/
	@Excel(name = "创意标题", width = 15)
    @ApiModelProperty(value = "创意标题")
	private String title;
	/**创意状态*/
	@Excel(name = "创意状态", width = 15)
    @ApiModelProperty(value = "创意状态")
    private String status;
    /**
     * 创意状态
     */
	@Excel(name = "创意状态", width = 15)
	@ApiModelProperty(value = "创意状态")
    private String optStatus;
	/**创意类型*/
	@Excel(name = "创意类型", width = 15)
    @ApiModelProperty(value = "创意类型")
	private String imageMode;
	/**图片素材信息*/
	@Excel(name = "图片素材信息", width = 15)
    @ApiModelProperty(value = "图片素材信息")
	private String imageInfo;
	/**createTime*/
    @ApiModelProperty(value = "createTime")
	private Date createTime;
	/**updateTime*/
    @ApiModelProperty(value = "updateTime")
	private Date updateTime;

    public ByteDanceCreativeMaterial() {
    }

    public ByteDanceCreativeMaterial(JSONObject dataObject, String accountId) {
		this.id = dataObject.getLong("id");
		this.toutiaoId = dataObject.getLong("advertiser_id");

		String status = dataObject.getString("status");
		if (null!=status&&!"".equals(status.trim())){
			this.status = status;
		}

		Long ad_id = dataObject.getLong("ad_id");
		if (null!=ad_id){
			this.adId = ad_id;
		}

		String title = dataObject.getString("title");
		if (null!=title&&!"".equals(title.trim())){
			this.title = title;
		}

		String image_mode = dataObject.getString("image_mode");
		if (null!=image_mode&&!"".equals(image_mode.trim())){
			this.imageMode = image_mode;
		}

		String image_info = dataObject.getString("image_info");
		if (null!=image_info&&!"".equals(image_info.trim())){
			this.imageInfo = image_info;
		}

		String opt_status = dataObject.getString("opt_status");
		if (null!=opt_status&&!"".equals(opt_status.trim())){
			this.optStatus = opt_status;
		}
	}
}
