package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 今日头条受众模板信息
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_user_orientation_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_user_orientation_template对象", description = "今日头条受众模板信息")
public class ByteDanceUserOrientationTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 头条账号id
     */
    @Excel(name = "头条账号id", width = 15)
    @ApiModelProperty(value = "头条账号id")
    private Long accountId;
    /**
     * 广告主id
     */
    @Excel(name = "广告主id", width = 15)
    @ApiModelProperty(value = "广告主id")
    private String advertiserId;
    /**
     * 模板名称
     */
    @Excel(name = "模板名称", width = 15)
    @ApiModelProperty(value = "模板名称")
    private String name;
    /**
     * 定向人群包列表
     */
    @Excel(name = "定向人群包列表", width = 15)
    @ApiModelProperty(value = "定向人群包列表")
    private String retargetingTagsInclude;
    /**
     * 排除人群包列表
     */
    @Excel(name = "排除人群包列表", width = 15)
    @ApiModelProperty(value = "排除人群包列表")
    private String retargetingTagsExclude;
    /**
     * 受众性别
     */
    @Excel(name = "受众性别", width = 15)
    @ApiModelProperty(value = "受众性别")
    private String gender;
    /**
     * 年龄
     */
    @Excel(name = "年龄", width = 15)
    @ApiModelProperty(value = "年龄")
    private String age;
    /**
     * 受众最低android版本
     */
    @Excel(name = "受众最低android版本", width = 15)
    @ApiModelProperty(value = "受众最低android版本")
    private String androidOsv;
    /**
     * 受众最低ios版本
     */
    @Excel(name = "受众最低ios版本", width = 15)
    @ApiModelProperty(value = "受众最低ios版本")
    private String iosOsv;
    /**
     * 运营商类型
     */
    @Excel(name = "运营商类型", width = 15)
    @ApiModelProperty(value = "运营商类型")
    private String carrier;
    /**
     * 受众网络类型
     */
    @Excel(name = "受众网络类型", width = 15)
    @ApiModelProperty(value = "受众网络类型")
    private String ac;
    /**
     * 手机品牌
     */
    @Excel(name = "手机品牌", width = 15)
    @ApiModelProperty(value = "手机品牌")
    private String deviceBrand;
    /**
     * 受众文章分类
     */
    @Excel(name = "受众文章分类", width = 15)
    @ApiModelProperty(value = "受众文章分类")
    private String articleCategory;
    /**
     * 用户首次激活时间
     */
    @Excel(name = "用户首次激活时间", width = 15)
    @ApiModelProperty(value = "用户首次激活时间")
    private String activateType;
    /**
     * 受众平台
     */
    @Excel(name = "受众平台", width = 15)
    @ApiModelProperty(value = "受众平台")
    private String platform;
    /**
     * 地域定向城市或者区县列表
     */
    @Excel(name = "地域定向城市或者区县列表", width = 15)
    @ApiModelProperty(value = "地域定向城市或者区县列表")
    private String city;
    /**
     * 商圈ID数组
     */
    @Excel(name = "商圈ID数组", width = 15)
    @ApiModelProperty(value = "商圈ID数组")
    private String businessIds;
    /**
     * 地域类型
     */
    @Excel(name = "地域类型", width = 15)
    @ApiModelProperty(value = "地域类型")
    private String district;
    /**
     * 受众位置类型
     */
    @Excel(name = "受众位置类型", width = 15)
    @ApiModelProperty(value = "受众位置类型")
    private String locationType;
    /**
     * 兴趣分类
     */
    @Excel(name = "兴趣分类", width = 15)
    @ApiModelProperty(value = "兴趣分类")
    private String adTag;
    /**
     * 兴趣关键词, 传入具体的词id，非兴趣词包id
     */
    @Excel(name = "兴趣关键词, 传入具体的词id，非兴趣词包id", width = 15)
    @ApiModelProperty(value = "兴趣关键词, 传入具体的词id，非兴趣词包id")
    private String interestTags;
    /**
     * 行为定向
     */
    @Excel(name = "行为定向", width = 15)
    @ApiModelProperty(value = "行为定向")
    private String appBehaviorTarget;
    /**
     * APP行为定向,分类集合
     */
    @Excel(name = "APP行为定向,分类集合", width = 15)
    @ApiModelProperty(value = "APP行为定向,分类集合")
    private String appCategory;
    /**
     * APP行为定向,APP集合
     */
    @Excel(name = "APP行为定向,APP集合", width = 15)
    @ApiModelProperty(value = "APP行为定向,APP集合")
    private String appIds;
    /**
     * 产品目录ID(ID由查询产品目录接口得到)
     */
    @Excel(name = "产品目录ID(ID由查询产品目录接口得到)", width = 15)
    @ApiModelProperty(value = "产品目录ID(ID由查询产品目录接口得到)")
    private String productPlatformId;
    /**
     * H5地址参数
     */
    @Excel(name = "H5地址参数", width = 15)
    @ApiModelProperty(value = "H5地址参数")
    private String externalUrlParams;
    /**
     * 直达链接参数
     */
    @Excel(name = "直达链接参数", width = 15)
    @ApiModelProperty(value = "直达链接参数")
    private String openUrlParams;
    /**
     * 是否自定义商品定向
     */
    @Excel(name = "是否自定义商品定向", width = 15)
    @ApiModelProperty(value = "是否自定义商品定向")
    private String dpaLocalAudience;
    /**
     * 排除人群包
     */
    @Excel(name = "排除人群包", width = 15)
    @ApiModelProperty(value = "排除人群包")
    private String excludeCustomActions;
    /**
     * 包含人群包
     */
    @Excel(name = "包含人群包", width = 15)
    @ApiModelProperty(value = "包含人群包")
    private String includeCustomActions;
    /**
     * 精选流量包
     */
    @Excel(name = "精选流量包", width = 15)
    @ApiModelProperty(value = "精选流量包")
    private String superiorPopularityType;
    /**
     * 定向流量包ID数组
     */
    @Excel(name = "定向流量包ID数组", width = 15)
    @ApiModelProperty(value = "定向流量包ID数组")
    private String flowPackage;
    /**
     * 排除流量包ID数组
     */
    @Excel(name = "排除流量包ID数组", width = 15)
    @ApiModelProperty(value = "排除流量包ID数组")
    private String excludeFlowPackage;
    /**
     * status
     */
    @Excel(name = "status", width = 15)
    @ApiModelProperty(value = "status")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
