package org.jeecg.modules.ctop.entity;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.format.annotation.DateTimeFormat;
import org.jeecgframework.poi.excel.annotation.Excel;

/**
 * @Description: 投放目标模板信息
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
@Data
@TableName("ctop_bytedance_delivery_target_template")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_bytedance_delivery_target_template对象", description = "投放目标模板信息")
public class BytedanceDeliveryTargetTemplate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 头条平台id
     */
    @Excel(name = "头条平台id", width = 15)
    @ApiModelProperty(value = "头条平台id")
    private Long accountId;
    /**
     * 平台账号id
     */
    @Excel(name = "平台账号id", width = 15)
    @ApiModelProperty(value = "平台账号id")
    private String advertiserId;
    /**
     * 模板名称
     */
    @Excel(name = "模板名称", width = 15)
    @ApiModelProperty(value = "模板名称")
    private String name;
    /**
     * 投放目标
     */
    @Excel(name = "投放目标", width = 15)
    @ApiModelProperty(value = "投放目标")
    private String deliveryTarget;
    /**
     * 下载方式
     */
    @Excel(name = "下载方式", width = 15)
    @ApiModelProperty(value = "下载方式")
    private String downloadType;
    /**
     * 下载链接
     */
    @Excel(name = "下载链接", width = 15)
    @ApiModelProperty(value = "下载链接")
    private String downloadUrl;
    /**
     * 落地页链接
     */
    @Excel(name = "落地页链接", width = 15)
    @ApiModelProperty(value = "落地页链接")
    private String externalUrl;
    /**
     * 转化目标
     */
    @Excel(name = "转化目标", width = 15)
    @ApiModelProperty(value = "转化目标")
    private String convertTarget;
    /**
     * 应用包名
     */
    @Excel(name = "应用包名", width = 15)
    @ApiModelProperty(value = "应用包名")
    private String packageName;
    /**
     * 直达链接启用状态
     */
    @Excel(name = "直达链接启用状态", width = 15)
    @ApiModelProperty(value = "直达链接启用状态")
    private String openUrlStatus;
    /**
     * 直达链接生成方式
     */
    @Excel(name = "直达链接生成方式", width = 15)
    @ApiModelProperty(value = "直达链接生成方式")
    private String openUrlCreateMode;
    /**
     * 跳转app链接
     */
    @Excel(name = "跳转app链接", width = 15)
    @ApiModelProperty(value = "跳转app链接")
    private String redirectUrl;
    /**
     * status
     */
    @Excel(name = "status", width = 15)
    @ApiModelProperty(value = "status")
    private Integer status;
    /**
     * createTime
     */
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
