package org.jeecg.modules.ctop.service.impl;

import org.apache.shiro.SecurityUtils;
import org.jeecg.common.system.vo.LoginUser;
import org.jeecg.modules.ctop.entity.BytedanceAdvertisePlanTemplate;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.mapper.BytedanceAdvertisePlanTemplateMapper;
import org.jeecg.modules.ctop.service.IBytedanceAdvertisePlanTemplateService;
import org.jeecg.modules.ctop.service.ICTopOauthTokenService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 广告计划模板信息
 * @Author: jeecg-boot
 * @Date: 2019-07-28
 * @Version: V1.0
 */
@Service
public class BytedanceAdvertisePlanTemplateServiceImpl extends ServiceImpl<BytedanceAdvertisePlanTemplateMapper, BytedanceAdvertisePlanTemplate> implements IBytedanceAdvertisePlanTemplateService {

    @Override
    public Map<String, Object> insertTemplate(BytedanceAdvertisePlanTemplate template) {
        Map<String, Object> resultMap = new HashMap<>();
        LoginUser user = (LoginUser) SecurityUtils.getSubject().getPrincipal();
        CTopOauthToken token = tokenService.getOAuthTokenByAccountId(user.getId());
        template.setAccountId(token.getAccountId());
        template.setAdvertiserId(token.getAdvertiserId());
//        template.setStatus(1);
        templateMapper.insert(template);
        resultMap.put("success", true);
        resultMap.put("message", "投放目标模板保存成功");
        return resultMap;
    }

    @Autowired
    private BytedanceAdvertisePlanTemplateMapper templateMapper;
    @Autowired
    private ICTopOauthTokenService tokenService;
}
