package org.jeecg.modules.ctop.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import org.jeecg.modules.ctop.entity.CTopOauthToken;
import org.jeecg.modules.ctop.mapper.CTopOauthTokenMapper;
import org.jeecg.modules.ctop.service.ICTopOauthTokenService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

/**
 * @Description: oauth授权码
 * @Author: jeecg-boot
 * @Date:   2019-07-09
 * @Version: V1.0
 */
@Service
public class CTopOauthTokenServiceImpl extends ServiceImpl<CTopOauthTokenMapper, CTopOauthToken> implements ICTopOauthTokenService {

    @Autowired
    private CTopOauthTokenMapper cTopOauthTokenMapper;

    @Override
    public CTopOauthToken getOAuthTokenByAccountId(String accountId) {
        QueryWrapper<CTopOauthToken> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("advertiser_id", accountId).orderByDesc("create_time");
        CTopOauthToken cTopOauthToken = cTopOauthTokenMapper.selectOne(queryWrapper);
        return cTopOauthToken;
    }
}
