package org.jeecg.modules.fileupload.service.impl;

import cn.com.ctop.common.utils.FileEntity;
import cn.com.ctop.common.utils.FileUploadTool;
import org.jeecg.modules.ctop.entity.FileInfo;
import org.jeecg.modules.ctop.mapper.FileInfoMapper;
import org.jeecg.modules.fileupload.service.IUploadService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;

@Service
public class UploadServiceImpl implements IUploadService {

    @Autowired
    private FileInfoMapper fileInfoMapper;

    @Override
    public Map<String, Object> imageUpload(MultipartFile multipartFile, HttpServletRequest request, String type) {
        Map<String, Object> resultMap = new HashMap<>();
        String savaPath = "D:\\upload\\image";
        FileUploadTool fileUploadTool = new FileUploadTool();
        FileEntity entity;
        entity = fileUploadTool.createFile(multipartFile, request, savaPath);
        FileInfo fileInfo = new FileInfo();
        fileInfo.setFileName(entity.getTitleOrig());
        fileInfo.setPath(entity.getPath());
        fileInfo.setType("IMAGE");
        fileInfo.setFileUrl("http://photocdn.sohu.com/20111207/Img328215620.jpg");
        fileInfo.setPlatformType(type);
        fileInfoMapper.insert(fileInfo);
        resultMap.put("message", "文件上传成功");
        resultMap.put("success", true);
        resultMap.put("fileInfo", fileInfo);
        return resultMap;
    }

    @Override
    public Map<String, Object> videoUpload(MultipartFile multipartFile, HttpServletRequest request, String type) {
        Map<String, Object> resultMap = new HashMap<>();
        String savaPath = "D:\\upload\\video";
        FileUploadTool fileUploadTool = new FileUploadTool();
        FileEntity entity;
        entity = fileUploadTool.createFile(multipartFile, request, savaPath);
        FileInfo fileInfo = new FileInfo();
        fileInfo.setFileName(entity.getTitleOrig() + entity.getType());
        fileInfo.setPath(entity.getPath());
        fileInfo.setType("VIDEO");
        fileInfo.setFileUrl("http://photocdn.sohu.com/20111207/Img328215620.jpg");
        fileInfo.setPlatformType(type);
        fileInfoMapper.insert(fileInfo);
        resultMap.put("message", "文件上传成功");
        resultMap.put("success", true);
        resultMap.put("fileInfo", fileInfo);
        return resultMap;
    }
}
