package org.jeecg.modules.kuaishou.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Description: 创建应用
 * @Author: jeecg-boot
 * @Date: 2019-07-26
 * @Version: V1.0
 */
@Data
@TableName("ctop_kuaishou_app_create")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_app_create对象", description = "创建应用")
public class KuaiShouAppCreate {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 账户ID
     */
    @Excel(name = "账户ID", width = 15)
    @ApiModelProperty(value = "账户ID")
    private Long accountId;
    /**
     * 本地存储地址
     */
    @Excel(name = "本地存储地址", width = 15)
    @ApiModelProperty(value = "本地存储地址")
    private Object savaPath;
    /**
     * 上传应用地址
     */
    @Excel(name = "上传应用地址", width = 15)
    @ApiModelProperty(value = "上传应用地址")
    private Object url;
    /**
     * 应用标记
     */
    @Excel(name = "应用标记", width = 15)
    @ApiModelProperty(value = "应用标记")
    private String appVersion;
    /**
     * 应用名称
     */
    @Excel(name = "应用名称", width = 15)
    @ApiModelProperty(value = "应用名称")
    private String appName;
    /**
     * 图片token
     */
    @Excel(name = "图片token", width = 15)
    @ApiModelProperty(value = "图片token")
    private Object imageToken;
    /**
     * 应用包名
     */
    @Excel(name = "应用包名", width = 15)
    @ApiModelProperty(value = "应用包名")
    private String packageName;
    /**
     * 应用类型 1： Android 应用下载，2： Android 网页游戏，3： iOS 应用下载， 4：iOS 网页游戏
     */
    @Excel(name = "应用类型 1： Android 应用下载，2： Android 网页游戏，3： iOS 应用下载， 4：iOS 网页游戏", width = 15)
    @ApiModelProperty(value = "应用类型 1： Android 应用下载，2： Android 网页游戏，3： iOS 应用下载， 4：iOS 网页游戏")
    private Integer platform;
    /**
     * 请求成功后 返回应用地址
     */
    @Excel(name = "请求成功后 返回应用地址", width = 15)
    @ApiModelProperty(value = "请求成功后 返回应用地址")
    private Object returnUrl;
    /**
     * 应用id
     */
    @Excel(name = "应用id", width = 15)
    @ApiModelProperty(value = "应用id")
    private Long appId;
    /**
     * 文件上传时间
     */
    @Excel(name = "文件上传时间", width = 15)
    @ApiModelProperty(value = "文件上传时间")
    private String uploadTime;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
