package org.jeecg.modules.kuaishou.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Description: 广告组-app信息
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
@Data
@TableName("ctop_kuaishou_app_info")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_app_info对象", description = "广告组-app信息")
public class KuaiShouAppInfo {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * accountId
     */
    @Excel(name = "accountId", width = 15)
    @ApiModelProperty(value = "accountId")
    private Long accountId;
    /**
     * 广告组id
     */
    @Excel(name = "广告组id", width = 15)
    @ApiModelProperty(value = "广告组id")
    private Long unitId;
    /**
     * appPackageName
     */
    @Excel(name = "appPackageName", width = 15)
    @ApiModelProperty(value = "appPackageName")
    private String appPackageName;
    /**
     * appName
     */
    @Excel(name = "appName", width = 15)
    @ApiModelProperty(value = "appName")
    private String appName;
    /**
     * deviceOsType
     */
    @Excel(name = "deviceOsType", width = 15)
    @ApiModelProperty(value = "deviceOsType")
    private Integer deviceOsType;
    /**
     * createTime
     */
    @Excel(name = "createTime", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "createTime")
    private Date createTime;
    /**
     * updateTime
     */
    @Excel(name = "updateTime", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "updateTime")
    private Date updateTime;
}
