package org.jeecg.modules.kuaishou.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Description: 快手-创建广告计划
 * @Author: jeecg-boot
 * @Date: 2019-07-23
 * @Version: V1.0
 */
@Data
@TableName("ctop_kuaishou_campaign_create")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_campaign_create对象", description = "快手-创建广告计划")
public class KuaiShouCampaignCreate {

    /**
     * 账户ID
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "账户ID")
    private Long id;
    /**
     * 账户ID
     */
    @Excel(name = "账户ID", width = 15)
    @ApiModelProperty(value = "账户ID")
    private Long accountId;
    /**
     * 广告计划名称
     */
    @Excel(name = "广告计划名称", width = 15)
    @ApiModelProperty(value = "广告计划名称")
    private String campaignName;
    /**
     * 2:提升应用安装 3:获取电商下单 4:推广品牌活动 5:收集销售线索
     */
    @Excel(name = "2:提升应用安装 3:获取电商下单 4:推广品牌活动 5:收集销售线索", width = 15)
    @ApiModelProperty(value = "2:提升应用安装 3:获取电商下单 4:推广品牌活动 5:收集销售线索")
    private Integer type;
    /**
     * 计划单日预算金额 单位：厘 0表示预算不限，不小于500元，不超过100000000
     */
    @Excel(name = "计划单日预算金额 单位：厘 0表示预算不限，不小于500元，不超过100000000", width = 15)
    @ApiModelProperty(value = "计划单日预算金额 单位：厘 0表示预算不限，不小于500元，不超过100000000")
    private Integer dayBudget;
    /**
     * 广告计划id
     */
    @Excel(name = "广告计划id", width = 15)
    @ApiModelProperty(value = "广告计划id")
    private Long campaignId;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
