package org.jeecg.modules.kuaishou.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.jeecgframework.poi.excel.annotation.Excel;
import org.springframework.format.annotation.DateTimeFormat;

import java.util.Date;

/**
 * @Description: 快手-创建广告组定向信息
 * @Author: jeecg-boot
 * @Date: 2019-07-24
 * @Version: V1.0
 */
@Data
@TableName("ctop_kuaishou_group_create_target")
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value = "ctop_kuaishou_group_create_target对象", description = "快手-创建广告组定向信息")
public class KuaiShouGroupCreateTarget {

    /**
     * id
     */
    @TableId(type = IdType.AUTO)
    @ApiModelProperty(value = "id")
    private Long id;
    /**
     * 账户ID
     */
    @Excel(name = "账户ID", width = 15)
    @ApiModelProperty(value = "账户ID")
    private Long accountId;
    /**
     * 广告组ID
     */
    @Excel(name = "广告组ID", width = 15)
    @ApiModelProperty(value = "广告组ID")
    private Long unitId;
    /**
     * 地域
     */
    @Excel(name = "地域", width = 15)
    @ApiModelProperty(value = "地域")
    private Object region;
    /**
     * 年龄最小限制
     */
    @Excel(name = "年龄最小限制", width = 15)
    @ApiModelProperty(value = "年龄最小限制")
    private Integer ageMin;
    /**
     * 年龄最大限制
     */
    @Excel(name = "年龄最大限制", width = 15)
    @ApiModelProperty(value = "年龄最大限制")
    private Integer ageMax;
    /**
     * 性别 1：女性, 2：男性， 0：不限
     */
    @Excel(name = "性别 1：女性, 2：男性， 0：不限", width = 15)
    @ApiModelProperty(value = "性别 1：女性, 2：男性， 0：不限")
    private Integer gender;
    /**
     * 操作系统 1： Android， 2： iOS， 0：不限
     */
    @Excel(name = "操作系统 1： Android， 2： iOS， 0：不限", width = 15)
    @ApiModelProperty(value = "操作系统 1： Android， 2： iOS， 0：不限")
    private Integer platformOs;
    /**
     * 安卓版本  3：不限， 4： 4.x+， 5： 5.x+， 6： 6.x+， 7： 7.x+；
     */
    @Excel(name = "安卓版本  3：不限， 4： 4.x+， 5： 5.x+， 6： 6.x+， 7： 7.x+；", width = 15)
    @ApiModelProperty(value = "安卓版本  3：不限， 4： 4.x+， 5： 5.x+， 6： 6.x+， 7： 7.x+；")
    private Integer androidOsv;
    /**
     * ios版本  6：不限， 7： 7.x+， 8： 8.x+，9： 9.x+， 10： 10.x+
     */
    @Excel(name = "ios版本  6：不限， 7： 7.x+， 8： 8.x+，9： 9.x+， 10： 10.x+", width = 15)
    @ApiModelProperty(value = "ios版本  6：不限， 7： 7.x+， 8： 8.x+，9： 9.x+， 10： 10.x+")
    private Integer iosOsv;
    /**
     * 网络环境 1： Wi-Fi， 2：移动网络，0：表示不限
     */
    @Excel(name = "网络环境 1： Wi-Fi， 2：移动网络，0：表示不限", width = 15)
    @ApiModelProperty(value = "网络环境 1： Wi-Fi， 2：移动网络，0：表示不限")
    private Integer network;
    /**
     * 设备品牌 1： OPPO， 2： VIVO，3：华为， 4：小米，5：荣耀， 6：三星，7：金立， 8：魅族，9：乐视， 10：其他，11 ： 苹 果
     */
    @Excel(name = "设备品牌 1： OPPO， 2： VIVO，3：华为， 4：小米，5：荣耀， 6：三星，7：金立， 8：魅族，9：乐视， 10：其他，11 ： 苹 果", width = 15)
    @ApiModelProperty(value = "设备品牌 1： OPPO， 2： VIVO，3：华为， 4：小米，5：荣耀， 6：三星，7：金立， 8：魅族，9：乐视， 10：其他，11 ： 苹 果")
    private Object deviceBrand;
    /**
     * 设备价格 1： 1500 元以下，2： 1501~2000，3： 2001~2500，4： 2501~3000，5： 3001~3500，6： 3501~4000，7： 4001~4500，8： 4501~5000，9： 5001~5500，10： 5500 元以上
     */
    @Excel(name = "设备价格 1： 1500 元以下，2： 1501~2000，3： 2001~2500，4： 2501~3000，5： 3001~3500，6： 3501~4000，7： 4001~4500，8： 4501~5000，9： 5001~5500，10： 5500 元以上", width = 15)
    @ApiModelProperty(value = "设备价格 1： 1500 元以下，2： 1501~2000，3： 2001~2500，4： 2501~3000，5： 3001~3500，6： 3501~4000，7： 4001~4500，8： 4501~5000，9： 5001~5500，10： 5500 元以上")
    private Object devicePrice;
    /**
     * 创建时间
     */
    @Excel(name = "创建时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;
    /**
     * 修改时间
     */
    @Excel(name = "修改时间", width = 20, format = "yyyy-MM-dd HH:mm:ss")
    @JsonFormat(timezone = "GMT+8", pattern = "yyyy-MM-dd HH:mm:ss")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty(value = "修改时间")
    private Date updateTime;
}
