package cn.com.ctop.crawler.modules.core.service.impl;

import cn.com.ctop.crawler.modules.account.entity.KuaishouAdAccount;
import cn.com.ctop.crawler.modules.account.entity.KuaishouAppAccount;
import cn.com.ctop.crawler.modules.account.entity.KuaishouIosAccount;
import cn.com.ctop.crawler.modules.account.service.IKuaishouAppAccountService;
import cn.com.ctop.crawler.modules.core.service.IKuaishouCrawlerService;
import cn.com.ctop.crawler.modules.core.util.KuaishouUtil;
import cn.com.ctop.crawler.modules.log.entity.CrawlerLog;
import cn.com.ctop.crawler.modules.log.service.ICrawlerLogService;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.google.gson.Gson;
import org.jeecg.common.system.query.QueryGenerator;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Random;

@Service
public class KuaishouCrawlerServiceImpl implements IKuaishouCrawlerService {
    @Autowired
    private ICrawlerLogService crawlerLogService;
    @Autowired
    private IKuaishouAppAccountService kuaishouAppAccountService;
    public String getVideoFeeds(KuaishouAppAccount kuaishouAppAccount,Integer page){
        CrawlerLog crawlerLog = KuaishouUtil.kuaishouAppDataFeatch(
                kuaishouAppAccount.getUrl(),
                kuaishouAppAccount.getPath(),
                String.format(kuaishouAppAccount.getUrlParam(),String.valueOf(new Date().getTime())).replace(" ","-"),
                String.format(kuaishouAppAccount.getBodyParam(), String.valueOf(page.intValue()), String.valueOf(100 + page.intValue()), String.valueOf(page.intValue())),
                String.format(kuaishouAppAccount.getHeaderParam(), randomRequestId()),
                kuaishouAppAccount.getToken());
        if (crawlerLog != null){
//            crawlerLogService.save(crawlerLog);
            return crawlerLog.getResponseBody();
        }
        return null;
    }

    public String getVideoFeeds(KuaishouIosAccount kuaishouIosAccount){
        CrawlerLog crawlerLog = KuaishouUtil.kuaishouAppDataFeatch(
                kuaishouIosAccount.getUrl(),
                kuaishouIosAccount.getPath(),
                kuaishouIosAccount.getUrlParam().replace(" ","-"),
                kuaishouIosAccount.getBodyParam(),
                kuaishouIosAccount.getHeaderParam(),
                kuaishouIosAccount.getToken());
        if (crawlerLog != null){
//            crawlerLogService.save(crawlerLog);
            return crawlerLog.getResponseBody();
        }
        return null;
    }

    public String getUserProfile(Long userId) {
        CrawlerLog crawlerLog = KuaishouUtil.kuaishouAppDataFeatch("http://api.ksapisrv.com", "/rest/n/user/profile/v2", String.format("app=0&kpf=ANDROID_PHONE&ver=6.5&c=HUAWEI&mod=HUAWEI(ALP-AL00)&appver=6.5.6.9739&ftt=&isp=CUCC&kpn=KUAISHOU&lon=116.489647&language=zh-cn&sys=ANDROID_9&max_memory=384&ud=0&country_code=cn&oc=HUAWEI&hotfix_ver=&did_gt=%s&iuid=&net=WIFI&did=ANDROID_99fc74cb7188a11f&lat=39.958823", new Date().getTime()), String.format("token=5bc0b7924afc4a13a542a980138e20fd-1153842485&user=%s&sig=6417d1fcaa8b0e08cf95cb55f8071da1&client_key=3c2cd3f3&pv=true&__NStokensig=234e8e4c1f82a2e217bee01286fd8fa66f47461c78657901aa2e53dcdd1b811f", String.valueOf(userId)), String.format("User-Agent=kwai-android&Connection=keep-alive&Accept-Language=zh-cn&X-REQUESTID=%s&Content-Type=application/x-www-form-urlencoded&Host=api.ksapisrv.com", randomRequestId()), "2f8b6f33da6c4159bf5f2d7882af5bf1-1153842485");
        if (crawlerLog != null) {
//            crawlerLogService.save(crawlerLog);
            return crawlerLog.getResponseBody();
        }
        return null;
    }
    public String getAdAccountVideoFeeds(KuaishouAdAccount kuaishouAdAccount,String pcursor){
        CrawlerLog crawlerLog = KuaishouUtil.kuaishouAppDataFeatch("http://api.ksapisrv.com","/rest/n/feed/profile2",String.format("app=0&kpf=ANDROID_PHONE&ver=6.5&c=HUAWEI&mod=HUAWEI(ALP-AL00)&appver=6.5.6.9739&ftt=&isp=CUCC&kpn=KUAISHOU&lon=116.489647&language=zh-cn&sys=ANDROID_9&max_memory=384&ud=0&country_code=cn&oc=HUAWEI&hotfix_ver=&did_gt=%s&iuid=&net=WIFI&did=ANDROID_99fc74cb7188a11f&lat=39.958823",new Date().getTime()),String.format("token=2f8b6f33da6c4159bf5f2d7882af5bf1-1153842485&user_id=%s&lang=zh&count=30&privacy=public&referer=ks://profile/%s/-1/-1/8&browseType=1&sig=6417d1fcaa8b0e08cf95cb55f8071da1&client_key=3c2cd3f3&os=android&__NStokensig=d23103cf6c7c88a21ee3cfc07c34cd25879f522c72d237b8408fe6db086960b3&pcursor="+pcursor,kuaishouAdAccount.getKsid(),kuaishouAdAccount.getKsid()),String.format("User-Agent=kwai-android&Connection=keep-alive&Accept-Language=zh-cn&X-REQUESTID=%s&Content-Type=application/x-www-form-urlencoded&Host=api.ksapisrv.com",randomRequestId()),"2f8b6f33da6c4159bf5f2d7882af5bf1-1153842485");
        if (crawlerLog != null){
//            crawlerLogService.save(crawlerLog);
            return crawlerLog.getResponseBody();
        }
        return null;
    }

    public String getAdFeeds(){
        String token = "a7805c554d6a453ea3350b629b28fed9-1144829703";
        String staticStr = String.format("app=0&kpf=ANDROID_PHONE&ver=6.5&c=HUAWEI&mod=HUAWEI(VOG-AL10)&appver=6.5.5.9591&ftt=&isp=CUCC&kpn=KUAISHOU&lon=0&language=zh-cn&sys=ANDROID_9&max_memory=384&ud=1144829703&country_code=cn&pm_tag=&oc=HUAWEI&hotfix_ver=&did_gt=%s&iuid=&extId=4db221a192e4d1d713c5dafb204400a8&net=WIFI&did=ANDROID_07264410e70db2ca&lat=0",String.valueOf(new Date().getTime()));
        String paramStr = String.format("client_key=3c2cd3f3&os=android&__NStokensig=6338a81daf2be08b4dfcec2867fd39c45ffa59f02a3b687e80e1f1eafd3053e5&token=%s",token);
        String headerStr = String.format("User-Agent=kwai-android&Connection=keep-alive&Accept-Language=zh-cn&X-REQUESTID=%s&Content-Type=application/x-www-form-urlencoded&Host=api.ksapisrv.com",randomRequestId());
        String url = "http://api.ksapisrv.com";
        String path = "/rest/n/ad/list";
        CrawlerLog crawlerLog = KuaishouUtil.kuaishouAppDataFeatch(url,path,staticStr,paramStr,headerStr,token);
//        crawlerLogService.save(crawlerLog);
        return crawlerLog.getResponseBody();
    }

    private String randomRequestId() {
        int temp = 436669999 - 436650000;
        int nextInt = new Random().nextInt(temp) + 436650000;
        return String.valueOf(nextInt);
    }

    public static void main(String[] args){
        KuaishouCrawlerServiceImpl k = new KuaishouCrawlerServiceImpl();
        String uid = "986048441";
        CrawlerLog log = KuaishouUtil.kuaishouAppDataFeatch("http://api.ksapisrv.com","/rest/n/feed/profile2",String.format("app=0&kpf=ANDROID_PHONE&ver=6.5&c=HUAWEI&mod=HUAWEI(ALP-AL00)&appver=6.5.6.9739&ftt=&isp=CUCC&kpn=KUAISHOU&lon=116.489647&language=zh-cn&sys=ANDROID_9&max_memory=384&ud=0&country_code=cn&oc=HUAWEI&hotfix_ver=&did_gt=%s&iuid=&net=WIFI&did=ANDROID_99fc74cb7188a11f&lat=39.958823",new Date().getTime()),String.format("token=2f8b6f33da6c4159bf5f2d7882af5bf1-1153842485&user_id=%s&lang=zh&count=30&privacy=public&referer=ks://profile/%s/-1/-1/8&browseType=1&sig=6417d1fcaa8b0e08cf95cb55f8071da1&client_key=3c2cd3f3&os=android&__NStokensig=d23103cf6c7c88a21ee3cfc07c34cd25879f522c72d237b8408fe6db086960b3",uid,uid),String.format("User-Agent=kwai-android&Connection=keep-alive&Accept-Language=zh-cn&X-REQUESTID=%s&Content-Type=application/x-www-form-urlencoded&Host=api.ksapisrv.com",k.randomRequestId()),"2f8b6f33da6c4159bf5f2d7882af5bf1-1153842485");
        System.out.println(log.getResponseBody());
    }
}
